
/*
* This Java Bean and all of the other "Beans" in this offering are
* copyright 2002 by Peter Wayner. 
*   


 * This bean is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This bean is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * Or go to http://www.gnu.org
 * 
 
 */


import java.util.Vector;
import java.math.BigInteger;

public class BigIntegerBitArray{

// pulls bits out of a BigInteger

	BigInteger number;
	int bitCount;
	
	int currentBit=0;
	
	public void setCurrentBit(){
	   currentBit=bitCount-1;
	}
	
	
	
	public BigIntegerBitArray(){
	   number=new BigInteger("0");
	   bitCount=number.bitLength();
	   setCurrentBit();
	}

	public BigIntegerBitArray(long l){
	   number=new BigInteger(""+l);
	   bitCount=number.bitLength();
	   setCurrentBit();
	}
	
	public BigIntegerBitArray(BigInteger l){
	   number=l;
	   bitCount=number.bitLength();
	   setCurrentBit();
	}

	
	public void setNumber(BigInteger b){
	   number=b;
	   bitCount=number.bitLength();	   
	   setCurrentBit();
	}

	public void setNumber(long l){
	   setNumber(new BigInteger(""+l));
	 }

	
	public long getBits(int howMany){
	    long ans=0;
	    if (howMany<64){
	       for (int i=0;i<howMany;i++){
	          ans=2*ans;/// note this doesn't matter the first pass. ans=0;
	          ///System.out.println("Getting bit="+currentBit+" is "+number.testBit(currentBit));
	          if ((currentBit>=0) && (number.testBit(currentBit))){/// effectively pad by zero
	             ans++;
	          }
	          currentBit--;
	       }
	    }
	   return ans;
	}

	public String toString(){
	  return number.toString()+"( at bit="+currentBit+", total="+bitCount+")";
	
	}
}