/*
* This Java Bean and all of the other "Beans" in this offering are
* copyright 2002 by Peter Wayner. 
*   


 * This bean is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This bean is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * Or go to http://www.gnu.org
 * 
 
 */


import java.util.Vector;
import java.math.BigInteger;

public class ListTransformer{


    Vector items=new Vector();
    int count=0;
    
    public int getCount(){
      return count;
    }
    
    public int getApproxMax(){
      BigInteger ans=BigInteger.valueOf(1);
      count=items.size();
      for (int i=2;i<=count;i++){
        ans=ans.multiply(BigInteger.valueOf(i));
      }
      return ans.bitLength()-1;
    }
   
    public int howManyNeeded(BigInteger top){
      // find out how many are needed to get bigger than max
      //BigInteger top=BigInteger.valueOf(max);
      BigInteger ans=BigInteger.valueOf(1);
      int i=2;
      while (top.compareTo(ans)==1){
        ans=ans.multiply(BigInteger.valueOf(i));
        i++;
      }
      return i-1;
    }
    
    
    public void addTextField(String s){
      items=new Vector();
      count=0;
      int lastPos=0;
      int pos=s.indexOf('\n');
      String ss;
      while (pos>=0){
        if (pos>lastPos){
          ss=s.substring(lastPos,pos);
          addItem(ss);
          count++;
        }
        lastPos=pos+1;
        pos=s.indexOf('\n',lastPos);
      }
    }
    
    public void addItem(String s, int i){
       LineItem l=new LineItem(s,i);
       items.addElement(l);
    }
    
   public void addItem(String s){
       LineItem l=new LineItem(s);
       items.addElement(l);
    }
     
    
     public int findNum(int pos){
       int i=0;
       int unchosen=0;
       while ((i<count) && (((LineItem)items.elementAt(i)).getCanonicalPosition()!=pos) ){
          i++;
       }
       if (i==count){
         return -1;
       } else {
         return i;
       }
    }
    
    public void resetList(){
      LineItem l;
           count=items.size();
      for (int i=0;i<count;i++){
        l=(LineItem)items.elementAt(i);
        l.notChosen=true;
       }
    }
    
    public int findUnchosenNum(int pos){
       int i=0;
       int unchosen=0;
       while ((i<count) && (((LineItem)items.elementAt(i)).getCanonicalPosition()!=pos) ){
         if (((LineItem)(items.elementAt(i))).notChosen) unchosen++;
         i++;
       }
       if (i==count){
         return -1;
       } else {
         ((LineItem)items.elementAt(i)).notChosen=false;
         return unchosen;
       }
    }
    
    public long listToLong(){
       long ans=0;
       int p;
       resetList();
       for (int i=count;i>1;i--){
          p=findUnchosenNum(i-1);
        //  System.out.println("find num:"+(i-1)+" at p="+p+" ans="+ans);
///          printList();
          if (p==-1){
             return -1;
          }
          ans=(ans+p)*(i-1);
       }
       return ans;
    }

  public BigInteger listToBigInteger(){
       BigInteger ans=BigInteger.valueOf(0);
       int p;
       resetList();
       for (int i=count;i>1;i--){
          p=findUnchosenNum(i-1);
        //  System.out.println("find num:"+(i-1)+" at p="+p+" ans="+ans);
///          printList();
          if (p==-1){
             return BigInteger.valueOf(-1);
          }
          ans=(ans.add(BigInteger.valueOf(p))).multiply(BigInteger.valueOf(i-1));
       }
       return ans;
    }


   public Vector longToList(long l){
     int p;
     long pos;
     count=items.size();
     Vector ans=new Vector();
     p=findNum(0);
     ans.addElement(items.elementAt(p));
      for (int i=1;i<count;i++){
        p=findNum(i);
        pos=l % (i+1);
     //   System.out.println("-- position:"+pos+" item p:"+p+" l="+l);
        ans.insertElementAt(items.elementAt(p),(int)pos);
        l=(l-pos)/(i+1);
       }
      return ans;
   }
   
     public Vector bigIntegerToList(BigInteger l){
     int p;
     BigInteger pos;
     Vector ans=new Vector();
     count=items.size();           
     p=findNum(0);
     ans.addElement(items.elementAt(p));
      for (int i=1;i<count;i++){
        p=findNum(i);
        pos=l.mod(BigInteger.valueOf(i+1));
     //   System.out.println("-- position:"+pos+" item p:"+p+" l="+l);
        ans.insertElementAt(items.elementAt(p),pos.intValue());
        l=(l.subtract(pos)).divide(BigInteger.valueOf(i+1));
       }
      return ans;
   }
   
   
   
   public void reorderListByLong(long l){
      items=longToList(l);
   }
   
   public String reorderedListByBigInteger(BigInteger b){
     Vector v=bigIntegerToList(b);
     StringBuffer sb=new StringBuffer();
     int sz=v.size();
     LineItem l;
     for (int i=0;i<sz;i++){
       l=(LineItem)v.elementAt(i);
       sb.append(l.s);
       sb.append('\n');
     }
     return sb.toString();
   }
   

   public void printList(){
     count=items.size();
     for (int i=0;i<count;i++){
       System.out.println(items.elementAt(i));
     }
   }
   
   
   
   public void computeCanonicalOrder(String password){
     int si=items.size();
     LineItem l;
     for (int i=0;i<si;i++){
       l=(LineItem)items.elementAt(i);
       l.setSortString(password);
     }
     Vector i2=(Vector)items.clone();
     try{ 
       sort(i2);
     } catch (Exception e){
     
     }
     for (int i=0;i<si;i++){
       l=(LineItem)i2.elementAt(i);
       l.canonicalPosition=i;
     }
   }


	     static void   QuickSort(Vector a, int lo0, int hi0) throws Exception
   {
      int lo = lo0;
      int hi = hi0;
      String mid;
      String temp;

      if ( hi0 > lo0)
      {

         /* Arbitrarily establishing partition element as the midpoint of
          * the array.
          */
         //mid = a[ ( lo0 + hi0 ) / 2 ];

         mid=((LineItem)(a.elementAt((lo0+hi0)/2))).getSortString();

         // loop through the array until indices cross
         while( lo <= hi )
         {
            /* find the first element that is greater than or equal to 
             * the partition element starting from the left Index.
             */
	     while( ( lo < hi0 )   && ( (temp=((LineItem)(a.elementAt(lo))).getSortString()).compareTo(mid)<0))
		 ++lo;

            /* find an element that is smaller than or equal to 
             * the partition element starting from the right Index.
             */
	     while( ( hi > lo0 )   && ((temp= ((LineItem)(a.elementAt(hi))).getSortString()).compareTo(mid)>0 ))
		 --hi;

            // if the indexes have not crossed, swap
            if( lo <= hi )
            {
               swap(a, lo, hi);
               ++lo;
               --hi;
            }
         }

         /* If the right index has not reached the left side of array
          * must now sort the left partition.
          */
         if( lo0 < hi )
            QuickSort( a, lo0, hi );

         /* If the left index has not reached the right side of array
          * must now sort the right partition.
          */
         if( lo < hi0 )
            QuickSort( a, lo, hi0 );

      }
   }

   private static void swap(Vector a, int i, int j)
   {
      Object X,Y;
      X = a.elementAt(i);
      Y=a.elementAt(j);
      a.setElementAt(X,j);
      a.setElementAt(Y,i);


   }

   public static void sort(Vector a) throws Exception
   {
      QuickSort(a,  0, a.size() - 1);
   }



}