
/*
* This Java Bean and all of the other "Beans" in this offering are
* copyright 2002 by Peter Wayner. 
*   


 * This bean is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This bean is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * Or go to http://www.gnu.org
 * 
 
 */


import java.util.Vector;
import java.math.BigInteger;

public class Word  {

	char firstChar;
	char lastChar;
	
	StringBuffer doubleLetters=new StringBuffer();
	
	boolean encodingCapable=false;
	
	public boolean getEncodingCapable(){
	   return encodingCapable;
	}
	
    String me;
	public ListTransformer lt;
	
	public Word(String s){
	   me=s;
	   lt=wordToList(me);
	   firstChar=me.charAt(0);
	   lastChar=me.charAt(me.length()-1);
	}
	
	public void setPassword(String password){
	   lt.computeCanonicalOrder(password);
	}
	
	public void encodeBits(long l){
	    lt.reorderListByLong(l);
	}
	
	public long extractBits(){
	   return lt.listToLong();
	}
	
	public int getBitCapacity(){
	   return lt.getApproxMax();
	}
	
	
	public int count(String s, char c){
	  /// count how many times c appears in s.
	  /// exclude the first and last character for this application.
	  /// I know this is an O(n^2) algorithm, but I think it's
	  /// faster than all of that sorting for most words. At least
	  /// that's my guess. Feel free to prove me wrong by writing 
	  /// better code.
	  
	  int len=s.length()-1;
	  int ans=0;
	  for (int i=1;i<len;i++){
	     if (s.charAt(i)==c) ans++;
	  }
	  return ans;
	}

	public ListTransformer wordToList(String s){
	   ListTransformer ans=null;
	   int len=s.length()-1;
	   int pos=-1;
	   int encodableChars=0;
	   char c;
	   if (len>1){
	      ans=new ListTransformer();
	      for (int i=1;i<len;i++){ // skip first and last letters.
	          c=s.charAt(i);
	          if (count(s,c)==1){
				ans.addItem(""+s.charAt(i));
				encodableChars++;
			  } else {
			     /// store duplicates away.
			     doubleLetters.append(c);
			  }
	      }
	      if (encodableChars>1){
	        encodingCapable=true;
	      }
	    }
		return ans;
	}
	
	public String mixInDoubleLetters(StringBuffer sb){
	   char c;
	   int pos;
	   for (int i=0;i<doubleLetters.length();i++){
	     c=doubleLetters.charAt(i);
	     pos=(int)Math.round(Math.floor(Math.random()*(sb.length()-2)+1));
	     sb.insert(pos,c);
	   }
	   return sb.toString();
	}


	public String extractSortedWord(){
	    if (!encodingCapable){
	      return me;
	    } /// else 
	    StringBuffer ans=new StringBuffer();
	    ans.append(firstChar);
	    Vector fromHere=lt.items;
	    int count=lt.items.size();
        for (int i=0;i<count;i++){
          ans.append(((LineItem)fromHere.elementAt(i)).s);
        }
	    ans.append(lastChar);
        return mixInDoubleLetters(ans);// add back the missing letters.	
 	}

}