
/*
* This Java Bean/applet and all of the other "Beans" in this offering are
* copyright 2002 by Peter Wayner. 
*   


 * This bean/applet is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This bean is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * Or go to http://www.gnu.org
 * 
 
 */
 
 import java.util.Vector;
import java.math.BigInteger;

public class WordList{

	StringConverter sc;
	
	public void setSC(StringConverter s){
	  sc=s;
	}

	Vector list=new Vector();
	String text;
	
	public void reset(){
	   list=new Vector();
	}
	
	String password="nopasswordreally";
	
	public void setPassword(String s){
	   password=s;
	}
	
	
	public void addWord(String s){
	   list.addElement(new Word(s));
	}
	
	
	public void setText(String s){
	  text=s;
	  StringBuffer sb=new StringBuffer();
	  int len=s.length();
	  char c;
	  
	  for (int i=0;i<len;i++){
	     c=s.charAt(i);
	     if ((c>='A') && (c<='Z')){
	        sb.append(c);
	     } else if ((c>='a') && (c<='z')) {
	        sb.append(c);
	     } else {// default stop character.
	        if (sb.length()>0){
	           addWord(sb.toString());
	        }
	        addWord(""+c);// not most efficient way to convert char to string, I think.
	        sb=new StringBuffer();
	     }   
	   }
	  if (sb.length()>0){
	    addWord(sb.toString()); // add final word.
	  }
	}



    public void printSortedList(){
       int len=list.size();
       for (int i=0;i<len;i++){
          System.out.println(" word="+((Word)list.elementAt(i)).extractSortedWord());
       }
     }
     
    public String findSortedList(){
      StringBuffer sb=new StringBuffer();
       int len=list.size();
       for (int i=0;i<len;i++){
          sb.append(((Word)list.elementAt(i)).extractSortedWord());
       }
       return sb.toString();
    }

    public void printUnsortedList(){
       int len=list.size();
       for (int i=0;i<len;i++){
          System.out.println(" word="+((Word)list.elementAt(i)).me);
       }
     }
     
    public long power(int x,int exponent){
       long ans=x;
       for (int i=1;i<exponent;i++){
          ans=ans*x;
       }
       return ans;
    }

	public void encodeBits(BigIntegerBitArray bl){
	  int len=list.size();
	  int capacity;
	  long bits;
	  Word w;
      for (int i=0;i<len;i++){
        w=(Word)list.elementAt(i);
        if (w.encodingCapable){ // it can suck up some bits.
             capacity=w.getBitCapacity();
             w.setPassword(password);
             bits=bl.getBits(capacity);
             w.encodeBits(bits);
            System.out.println("Encoding in word:"+w.me+" with capacity="+capacity+" and bits:"+bits);

        }
	}
	}
	
	public void encodeBits(){
	  int len=list.size();
	  int capacity;
	  long bits;
	  Word w;
      for (int i=0;i<len;i++){
        w=(Word)list.elementAt(i);
        if (w.encodingCapable){ // it can suck up some bits.
            capacity=w.getBitCapacity();
             w.setPassword(password);
             bits=power(2,capacity)-1;
             w.encodeBits(bits);
            System.out.println("Encoding in word:"+w.me+" with capacity="+capacity+" and bits:"+bits);

        }
	}
	}
	
	
	public BigInteger extractBits(){
	  BigInteger ans=new BigInteger("0");
	  int len=list.size();
	  int capacity;
	  long bits;
	  Word w;
      for (int i=0;i<len;i++){
        w=(Word)list.elementAt(i);
        if (w.encodingCapable){ // it can suck up some bits.
            capacity=w.getBitCapacity();
             w.setPassword(password);
             bits=w.extractBits();
             ans=sc.appendLong(ans,bits,capacity);
            System.out.println("Extracting in word:"+w.me+" with capacity="+capacity+" and bits:"+bits);

        }
	}
	
	 return ans;
	}


}